note
	description: "Summary description for {COMMUNICATION}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	COMM_MANAGER
inherit
	THREAD

	INET_PROPERTIES

	THREAD

	STORABLE

create
	make

feature {NONE} -- Initialization

	state_machine: STATE_MACHINE

	lock: MUTEX

	port: INTEGER_32 = 12111

	listen_socket: NETWORK_STREAM_SOCKET

	client_socket: detachable NETWORK_STREAM_SOCKET

	message: detachable STRING_8

	make(sm: STATE_MACHINE; s:MUTEX)
		do
			lock := s
			Io.put_string ("starting plant server, port = " + Port.out + "%N")
			set_ipv4_stack_preferred (True)
			create listen_socket.make_server_by_port (Port)
			state_machine := sm
			launch
		end

	print_addresses
		do
			check
				attached client_socket as cs
			then
				check
					attached cs.address as csa and attached cs.peer_address as cspa
				then
					Io.put_string ("Accepted client on the listen socket address = " + csa.host_address.host_address + " port = " + csa.port.out + ".")
					Io.put_new_line
					Io.put_string ("%T Accepted client address = " + cspa.host_address.host_address + " , port = " + cspa.port.out)
					Io.put_new_line
				end
			end
		end

feature
	execute
		local
			done: BOOLEAN
--			msg1: MESSAGE
			t: TUPLE
		do

			listen_socket.listen (1)
			listen_socket.accept -- block
			client_socket := listen_socket.accepted
			check
				attached client_socket as cs
			then
				print_addresses
				from
					done := False
				until
					done
				loop
--					cs.read_line -- block
--					message := cs.last_string
					check
						attached {MESSAGE} retrieved (cs) as msg1
					then
						t := msg1.input
						print(t)
					end



--						message_interpretation (m.to_integer)
--						Io.put_string ("Client Says: ")
--						Io.put_string (m)

--						if m.is_case_insensitive_equal ("quit") then
--							done := True
--							cs.close
--						else
--							cs.put_string (m + "%N")
--						end
--						Io.put_new_line
--					end
				end
			end
			listen_socket.close
			Io.put_string ("finish echo_server%N")
		end


--	message_interpretation(m: INTEGER)
--		do
--			lock.lock
--			if m =0 then
--				state_machine.setg1 (false)
--				state_machine.setg2 (false)
--			elseif m = 1 then
--			state_machine.setg1 (true)
--				state_machine.setg2 (true)
--			elseif m = 2 then
--				state_machine.setg1 (true)
--				state_machine.setg2 (false)
--			elseif m = 3 then
--				state_machine.setg1 (false)
--				state_machine.setg2 (true)
--			end
--			lock.unlock
--		end

	message_interpretation(m: INTEGER)
		do
			lock.lock
			if m = 0 then
				state_machine.set_motor_guard (true)


			elseif m = 1 then
				state_machine.set_motor_guard (false)

			elseif m = 2 then

				state_machine.set_door_guard (true)

			elseif m = 3 then
				state_machine.set_door_guard (false)


			end
			lock.unlock
		end

end
