note
	description: "Summary description for {STATE_CONSTANTS}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	STATE_CONSTANTS

feature -- motor states

	off : STRING = "motor_off"
	starting: STRING = "motor_starting"
	on: STRING = "motor_on"
	stopping: STRING = "motor_stopping"

	is_motor_state(s: STRING) : BOOLEAN
		do
			Result :=
				s ~ off xor s ~ starting xor s ~ stopping xor s ~ on
		end

feature -- door states
	closed: STRING = "door_closed"
	opening: STRING = "door_opening"
	open: STRING = "door_open"
	closing: STRING = "door_closing"

		is_door_state(s: STRING) : BOOLEAN
		do
			Result :=
				s ~ closed xor s ~ opening xor s ~ open xor s ~ closing
		end



end
