note
	description: "Summary description for {EVENT}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	EVENT
inherit
	ABSTRACT_EVENT
		redefine state end
inherit {NONE}
	STATE_CONSTANTS

create
	make
feature
	count: INTEGER
	max: INTEGER = 20

	state: STATE

	execute
		local
			b: BOOLEAN
			time: INTEGER
		do
			from
				time := 1
			until
--				count = max
				false
			loop
				count := count + 1\\count.max_value
				state.mutex.lock
				print("Begin: " + name.out + count.out + "%N")
				print_state
				io.new_line
				if
					guard_holds
				then
					act
					print("Executed ...%N")
				end
				print_state; io.new_line
				print("End" + "%N" + "%N")
				state.mutex.unlock
				sleep (time * 1000000000)
			end
		end

	print_state
		do
			print(" b1,b2,x1,x2,mutex = ")
			print(state.input.b1.out +",")
			print(state.input.b2.out+",")
			print(state.output.x1.out+",")
			print(state.output.x2.out+",")
			print(state.mutex.is_set.out)
		end


end
